
program callLua2;
{$MODE OBJFPC}{$H+}

uses
  lua53;
  
var
  L: plua_state;

function luadivide(x, y: integer): integer;
begin
  (* the function name *)
  lua_getglobal(L, 'divide');
  (* the first argument *)
  lua_pushinteger(L, x);
  (* the second argument *)
  lua_pushinteger(L, y);
  (* call the function with 2 arguments, return 1 result *)
  lua_call(L, 2, 1);
  (* get the result *)
  result := lua_tointeger(L, -1);
  lua_pop(L, 1);
end;

var
  script: string;
  result: integer;
  
begin
  script := 'divide.lua';
  L := luaL_newstate();
  luaL_openlibs(L);
  if luaL_dofile(L, pChar(script)) <> 0 then 
  begin
    (* show if an error occured *)
    WriteLn(lua_tostring(L, -1));
  end;
  result := luadivide(10, 3);
  lua_close(L);
  WriteLn('result=', result);
end.
